<?php

/**
 * Copyright (c) 2014, Skalfa LLC
 * All rights reserved.
 *
 * ATTENTION: This commercial software is intended for exclusive use with SkaDate Dating Software (http://www.skadate.com) and is licensed under SkaDate Exclusive License by Skalfa LLC.
 *
 * Full text of this license can be found at http://www.skadate.com/sel.pdf
 */

/**
 *
 *
 * @author Kairat Bakitow <kainisoft@gmail.com>
 * @package ow_plugins.protected_photos.classes
 * @since 1.8.0
 */
class PROTECTEDPHOTOS_CLASS_PasswordFormElement extends TextField
{
    public function __construct( $name, $albumId )
    {
        parent::__construct($name);

        $password = PROTECTEDPHOTOS_BOL_Service::getInstance()->findPasswordForAlbumByAlbumId($albumId);

        if ( $password !== null && $password->privacy === PROTECTEDPHOTOS_BOL_Service::PRIVACY_PASSWORD )
        {
            $this->setValue($password->password);
        }

        $this->addAttribute('placeholder', OW::getLanguage()->text('protectedphotos', 'your_password'));
    }

    public function renderInput( $params = null )
    {
        return '<div id="ppp-password" class="ow_smallmargin" style="display: none">
            <div class="ow_pass_protected_privacy_pass_field">
                ' . parent::renderInput() . '<br>
                ' . UTIL_HtmlTag::generateTag('span', array('id' => $this->getId() . '_error', 'style' => 'display:none;', 'class' => 'error'), true) . '
            </div>
        </div>';

    }
}
