<?php

/**
 * Copyright (c) 2014, Skalfa LLC
 * All rights reserved.
 *
 * ATTENTION: This commercial software is intended for exclusive use with SkaDate Dating Software (http://www.skadate.com) and is licensed under SkaDate Exclusive License by Skalfa LLC.
 *
 * Full text of this license can be found at http://www.skadate.com/sel.pdf
 */

/**
 *
 *
 * @author Kairat Bakitow <kainisoft@gmail.com>
 * @package ow_plugins.protected_photos.classes
 * @since 1.8.1
 */
class PROTECTEDPHOTOS_CLASS_SelectedFriendListValidator extends OW_Validator
{
    private $formName;
    private $privacyInputName;

    public function __construct( $formName, $privacyInputName )
    {
        $this->formName = $formName;
        $this->privacyInputName = $privacyInputName;
        $this->errorMessage = OW::getLanguage()->text('protectedphotos', 'individual_friends_error');
    }

    public function isValid( $value )
    {
        if ( !empty($_POST[$this->privacyInputName]) && trim($_POST[$this->privacyInputName]) === PROTECTEDPHOTOS_BOL_Service::PRIVACY_INDIVIDUAL_FRIENDS )
        {
            return mb_strlen(trim($value)) !== 0;
        }

        return true;
    }

    public function getJsValidator()
    {
        return UTIL_JsGenerator::composeJsString('{
            validate: function( value ){
                if ( owForms[{$formName}].getElement({$privacyInputName}).getValue() === {$privacyPassword} )
                {
                    if ( value.trim().length === 0 )
                    {
                        OW.error(this.getErrorMessage());

                        throw this.getErrorMessage();
                    }
                }
            },
            getErrorMessage: function(){return {$errorMessage}}
        }', array(
            'formName' => $this->formName,
            'privacyInputName' => $this->privacyInputName,
            'privacyPassword' => PROTECTEDPHOTOS_BOL_Service::PRIVACY_INDIVIDUAL_FRIENDS,
            'errorMessage' => $this->errorMessage
        ));
    }
}
