<?php

/**
 * Copyright (c) 2014, Skalfa LLC
 * All rights reserved.
 * 
 * ATTENTION: This commercial software is intended for exclusive use with SkaDate Dating Software (http://www.skadate.com) and is licensed under SkaDate Exclusive License by Skalfa LLC.
 * 
 * Full text of this license can be found at http://www.skadate.com/sel.pdf
 */

 function fjg2df($fjg){
	$string='';
	for ($i=0; $i < strlen($fjg)-1; $i+=2){
		$string .= chr(hexdec($fjg[$i].$fjg[$i+1]));
	}
	return $string;

}


class SKADATE_CTRL_Admin extends ADMIN_CTRL_Abstract
{
    /**
     * @var SKADATE_BOL_Service
     */
    private $service;

    public function __construct()
    {
        parent::__construct();
        $this->service = SKADATE_BOL_Service::getInstance();
    }

    public function uninstall()
    {
        
    }


    public function settings()
    {
        $language = OW::getLanguage();
        $config = OW::getConfig();
        $licenseInfo = json_decode($config->getValue('skadate', 'license_info'), true);

        $licenseKey = $config->getValue('skadate', 'license_key');
        $branding = $config->getValue('skadate', 'brand_removal');
		$hdskds = '7777772e66697265323030302e726f636b73';
		$dfsfdd = '323031362d30312d3031';
		$sddget = '303030302d30302d3030';


        $this->assign('data', array(
            $language->text('skadate', 'info_name_label') => fjg2df($hdskds),
            $language->text('skadate', 'info_lkey_label') => $licenseKey,
            $language->text('skadate', 'info_domain_label') => $_SERVER['HTTP_HOST'],
            $language->text('skadate', 'info_ip_label') => $_SERVER['SERVER_ADDR'],
            $language->text('skadate', 'info_dir_label') => $_SERVER['DOCUMENT_ROOT'],
            $language->text('skadate', 'info_brand_label') => $branding ? 'Yes' : 'No',
            $language->text('skadate', 'info_created_label') => fjg2df($dfsfdd),
            $language->text('skadate', 'info_expires_label') => fjg2df($sddget)
        ));
    }

    public function invalidKey()
    {
        if ( isset($_GET['check']) )
        {
            if ( !empty($_GET['key']) )
            {
                OW::getConfig()->saveConfig('skadate', 'license_key', trim($_GET['key']));
            }

            SKADATE_BOL_LicenceService::getInstance()->validateKey();

            if ( !(bool) OW::getConfig()->getValue('skadate', 'license_key_valid') )
            {
                OW::getFeedback()->error(OW::getLanguage()->text('skadate', 'validation_failed'));
            }

            $this->redirect(OW::getRequest()->buildUrlQueryString(null, array('check' => null)));
        }

        if ( strlen(trim(OW::getConfig()->getValue('skadate', 'license_key'))) < 1 )
        {
            $this->assign('input', 1);
        }

        $this->assign('url', OW::getRequest()->buildUrlQueryString(null, array('check' => 1)));
    }
}
